{% extends "customers/base.html" %}
{% load staticfiles %}
{% load widget_tweaks %}

{% block title %}Promociones{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
<li class="breadcrumb-item"><a href="{% url 'promotions-list' %}">Promociones</a></li>
<!-- aqui va el id de la promocion -->
<li class="breadcrumb-item active">Promoción</li>
</ol>
<!-- end breadcrumb -->

<!-- begin page-header -->
<h1 class="page-header">Modificar <small>promoción</small></h1>
<!-- end page-header -->

<!-- begin row -->
<div class="row">
    <!-- begin col-12 -->
    <div class="col-xl-12 ui-sortable">
        <!-- begin panel -->
        <div class="panel panel-inverse" data-sortable-id="ui-general-1">
            <!-- begin panel-heading -->
            <div class="panel-heading ui-sortable-handle">
                <h4 class="panel-title">Modificar promoción</h4>
                <div class="panel-heading-btn">
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
                </div>
            </div>
            <!-- end panel-heading -->
            <!-- begin panel-body -->
            <div class="panel-body">
                <form method="post" class='form-horizontal'>
                    {% csrf_token %}
                    <div class="form-group m-b-15 col-sm-5" {%if need_to_hide %} hidden {%endif%} style='display: inline-block'>
                        <label for="id_initial_date" class="col-sm-4 control-label m-b-15">Fecha inicio:</label>
                        <div class="col-sm-12">
                            <input type="text" name="initial_date" value="{{init}}" class="form-control m-b-5 datepicker" id="id_initial_date" />

                        {% for error in form.initial_date.errors %}
                        <small class="f-s-12 text-danger">{{ error }}</small>
                        {% endfor %}
                    </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-5"   {%if need_to_hide %} hidden {%endif%} style='display: inline-block;'>
                        <label for="id_end_date" class="col-sm-4 control-label m-b-15">Fecha fin:</label>
                        <div class="col-sm-12">
                            {% render_field form.end_date class="form-control m-b-5 datepicker" %}
    
                            {% for error in form.end_date.errors %}
                            <small class="f-s-12 text-danger">{{ error }}</small>
                            {% endfor %}
                        </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-5" style='display: inline-block'>
                        <label for="id_name" class="col-sm-12 control-label m-b-15">Nombre de la promoción</label>
                        <div class="col-sm-12">
                            <input class="form-control m-b-5" type="text" name="name" maxlength="255" id="id_name" value="{{promotion.name}}" required/>
                        </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-5" style='display: inline-block'>
                        <label for="id_description" class="col-sm-12 control-label m-b-15">Descripcion de la promoción</label>
                        <div class="col-sm-12">
                            <input class="form-control m-b-5" type="text" name="description" maxlength="300" id="id_description" value="{{promotion.description}}"required/>
                        </div>
                    </div>
                    <div class="col-sm-11" style='padding-left:30px'>
                        <input type="submit" value="Actualizar" class="btn btn-primary">
                        <a href="{% url 'promotions-list' %}" class="btn btn-default">Cancelar</a>
                    </div>
                </form>
            <!-- end panel -->
            </div>
        </div>
    <!-- end column -->
    </div>
</div>
<!-- end row -->

<!-- begin scroll to top btn -->
<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
<!-- end scroll to top btn -->
{% endblock %}

{% block pageleveljs %}
<script>

$(document).ready(function(){
	$(".datepicker").datepicker({format: 'dd/mm/yyyy'});
	$("#id_initial_date").val($("#id_initial_date").val().replace(' 00:00:00',''));
	$("#id_end_date").val($("#id_end_date").val().replace(' 00:00:00',''));
	$("#id_initial_date").val($("#id_initial_date").val().replace(' 21:00:00',''));
	$("#id_end_date").val($("#id_end_date").val().replace(' 21:00:00',''));
	


	$(".form-horizontal").on("submit", function(){
		var nf = $("#id_initial_date").val()
		nf = nf.replace(' 00:00:00','')
		nf = nf.split('/')
		if (nf.length==3){
            var nfvalue = nf[2] + "-" + nf[1] + "-" + nf[0];
            $("#id_initial_date").val(nfvalue);
        }else{
            $("#id_initial_date").val(nf);
        }
		var nf = $("#id_end_date").val()
		nf = nf.replace(' 00:00:00','')
		nf = nf.split('/')
		if (nf.length==3){
            var nfvalue = nf[2] + "-" + nf[1] + "-" + nf[0];
            $("#id_end_date").val(nfvalue);
        }else{
            $("#id_end_date").val(nf);
        }
		return true;
	});

});

</script>
<script type="text/javascript">
    //active menu
    document.getElementById("promotions_menu").classList.add("active");
    //active submenu item
    document.getElementById("promotions_create_item").classList.add("active");
</script>

<script>
    var my_dict = JSON.parse("{{ my_dict|escapejs }}");
    var dynamicFields = $('#dynamic-fields-container').children().length;
    $('#id_periodos').change(function (e) {
        if (Number(e.target.value) > dynamicFields) {
            for (var i=dynamicFields;i<e.target.value;i++) {
                $('#dynamic-fields-container').append(
                    "<div style='display:flex; align-items: center'><label class='control-label col-sm-4 m-b-15'>Descuento para periodo "+(i+1)
                    +"</label><div class='col-sm-8 m-b-15' style='display:flex'><select id='tipo-descuento"+(i+1)+"' name='tipo-descuento"+(i+1)
                    +"' class='form-control m-b-5' required onchange='discountTypeCallback(&apos;tipo-descuento"+(i+1)+"&apos;)'>"
                    +"<option disabled selected value>Tipo de descuento</option><option value='percent'>Porcentaje</option><option "
                    +"value='amount'>Monto fijo</option></select><input required style='margin-left: 10px'class='form-control m-b-5' type='number' "
                    +"name='valor-descuento"+(i+1)+"' id='valor-descuento"+(i+1)+"'placeholder='Monto del descuento'/></div></div>"
                )
            }
            dynamicFields = Number(e.target.value);
        } else if (Number(e.target.value) < dynamicFields) {
            var fieldsToDelete = dynamicFields - e.target.value;
            for (var i=0;i<fieldsToDelete;i++) {
                $('#dynamic-fields-container').children().last().remove();
            }
            dynamicFields = Number(e.target.value)
        }
    })
    var discountTypeCallback = function(e) {
        var typeofDiscount=$('#'+e).val()
        var amountFieldId = e.replace('tipo', 'valor')
        if (typeofDiscount === 'percent') {
            $('#'+amountFieldId).attr('max', 100)
            $('#'+amountFieldId).attr('min', 1)
        } else {
            $('#'+amountFieldId).attr('min', 0)
        }
    }
    $('#id_operator').change(function(){
        var operator_id = $('#id_operator').val();
        $.get("/plans/ajax", {operator: operator_id}, function(data) {
            $('#id_plan').empty()
            $('#id_plan').append('<option disabled selected value>Seleccionar plan</option>')
            data.data.forEach(plan=>{
                $('#id_plan').append('<option value='+plan.pk+'>'+plan.name+'</option>')
            })
        });
    });

    $( "#id_initial_date" ).datepicker({
        showButtonPanel: true,
        minDate: my_dict, // minDate: '0' would work too
        beforeShowDay: noLastThreeDays,
        dateFormat: "dd/mm/yy"
    });
    $( "#id_end_date" ).datepicker({
        //minDate: my_dict, // minDate: '0' would work too
        dateFormat: "dd/mm/yy"
    });

    function noLastThreeDays(date){
        //REM: Last day of month
        var tLastDayOfMonth = new Date(date.getFullYear(), date.getMonth() + 1, 0);
        
        //REM: Date of the passed date
        var tDate = date.getDate();
        if (my_dict=='0'){
            return [true, "", ""]
        }
        //REM: Lock the last three days of the month
        if(
            tDate === 20 ||
            tDate === 21 ||
            tDate === 22 ||
            tDate === 23 ||
            tDate === 24 ||
            tDate === 25 ||
            tDate === 26 ||
            tDate === 27 ||
            tDate === 28 ||
            tDate === 29 ||
            tDate === 30 ||
            tDate === 31
        ){
            return [false, "closed", "Sorry We are closed"]
        }
        else{
        return [true, "", ""]
        }
    }
</script>
{% endblock %}